//*************************************************************************
// Program do obsugi siomierza - Szkoa Konstruktorw
// autor: Jakub Borzdyski
// Program pisany i kompilowany przy uyciu rodowiska WinAVR
//*************************************************************************
#include <io.h>
#include <avr/iom8.h>
#include <inttypes.h>
//********************************************************************************
void zapisz(char co) ;
//********************************************************************************
int main(){
	unsigned char temp ;
	unsigned char stan = 255 ;
	volatile uint32_t srednia = 0 ;
	volatile unsigned char licznik = 0, licznik_b = 0 ;
	

	//koncowki wskaznikow - ustaw
	outp(0xFF, DDRD);
	outp(0xFF, DDRB);
	outp(0xFF, PORTD);
	outp(0xFF, PORTB);

	//koncowka przetwornika - ustaw
	outp(0x00, PORTC);
	outp(0x00, DDRC);
	
	//konfiguracja ADC
	outp(0x21, ADMUX); //do lewej, kanal 1
	outp(0x86, ADCSRA);
	
	while(1){
	
		sbi(ADCSRA, ADSC); //start pomiaru
		while(bit_is_clear(ADCSRA, ADIF)){;} //oczekiwanie na zakonczenie
		cbi(ADCSR, ADIF); //wyzerowanie flagi pomiaru 
		
		licznik++ ;
		
		srednia += ADCH ;
		
		if(licznik==0){
			temp = srednia/255;
			if(stan>temp){stan=temp;}
			srednia = 0 ;
			licznik_b++;
		}
		
		if(licznik_b == 40){
			stan = stan - 80 ;
			stan /=3 ;
			zapisz(stan);
			stan =255;
			licznik_b = 0 ;
			
		}
	}
}
//*********************************************
void zapisz(char co){

	if(co>10){co=10;}
	
	switch(co){
		case 0:
			outp(0xFF, PORTB) ;
			outp(0xFF, PORTD) ;
			break ;
		case 1:
			outp(0xFD, PORTB) ;
			outp(0xFF, PORTD) ;
			break ;
		case 2:
			outp(0xFC, PORTB) ;
			outp(0xFF, PORTD) ;
			break ;
		case 3:
			outp(0xFC, PORTB) ;
			outp(0x7F, PORTD) ;
			break ;
		case 4:
			outp(0xFC, PORTB) ;
			outp(0x3F, PORTD) ;
			break ;
		case 5:
			outp(0xFC, PORTB) ;
			outp(0x1F, PORTD) ;
			break ;
		case 6:
			outp(0xFC, PORTB) ;
			outp(0x0F, PORTD) ;
			break ;
		case 7:
			outp(0xFC, PORTB) ;
			outp(0x07, PORTD) ;
			break ;
		case 8:
			outp(0xFC, PORTB) ;
			outp(0x03, PORTD) ;
			break ;
		case 9:
			outp(0xFC, PORTB) ;
			outp(0x01, PORTD) ;
			break ;
		case 10:
			outp(0xFC, PORTB) ;
			outp(0x00, PORTD) ;
			break ;
	}
}